'use strict';


/**************************************************************************************
GLOBALS
numColors: used in the pickColor functon to count the number of colors picked for the 
  palette
colorLimit: determined in the easy, medium, and hard functions. It represnts the max
  amount of colors we can have in our palette. If a user tries to go above this number
  an error is displayed
palette: this is the array that will hold our palette colors (used in many functions, 
  filled in pickColor)
***************************************************************************************/
var numColors;
var colorLimit;
var palette = []; 
var paletteHSV = [];
var paletteUpdate = [];
var w; 
var h;
var imageData;
var levelEasy = false;
var levelMedium = false;
var levelHard = false;
var firstTime = true;
var imgData;



/**************************************************************************************
FUNCTION PURPOSE: Gets uploaded image from file upload in HTML
PARMATERS: input (this represnts the image we input)
REFRENCES: https://www.w3schools.com/tags/att_input_type_file.asp
***************************************************************************************/
function readURL(input) {
	var image = document.getElementById('output'); //get my image from html file
	image.src = URL.createObjectURL(event.target.files[0]); //this is what loads the image from file upload
}

/**************************************************************************************
FUNCTION PURPOSE: On click for the easy button. Set colorLimit.
PARMATERS: none
***************************************************************************************/
function easy() //change to 6 8 and 10???
{
  numColors = 0; 
  levelEasy = true;
  colorLimit = 5;
  var easyButton = document.getElementById("e").style.background = '#FF0000';
  var easyButton = document.getElementById("m").style.background = '#696969';
  var easyButton = document.getElementById("h").style.background = '#696969';

  if(levelHard == true)
  {
    for(var i = 6; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    //delete last 13 canvasses
    levelHard = false;
  }
  else if (levelMedium == true)
  {
    for(var i = 6; i <11; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    levelMedium = false;
  }
  
}



/**************************************************************************************
FUNCTION PURPOSE: On click for the medium button
PARMATERS: none
***************************************************************************************/
function medium()
{
  numColors = 0;
  levelMedium = true;
  colorLimit = 10;
  var easyButton = document.getElementById("e").style.background = '#696969';
  var easyButton = document.getElementById("m").style.background = '#FF0000';
  var easyButton = document.getElementById("h").style.background = '#696969';

  if(levelHard == true)
  {
    //delete last 8 canvasses
    for(var i = 11; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "none";
    }
    levelHard = false;
  }
  else if (levelEasy == true)
  {
    for(var i = 6; i <11; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
     // var cContext = c.getContext("2d");

      //cContext.c.hidden = true;
    }
    levelEasy = false;
  }
}

/**************************************************************************************
FUNCTION PURPOSE: On click for the hard button
PARMATERS: none
***************************************************************************************/
function hard()
{
  numColors = 0;
  levelHard = true;
  colorLimit = 18;
  var easyButton = document.getElementById("e").style.background = '#696969';
  var easyButton = document.getElementById("m").style.background = '#696969';
  var easyButton = document.getElementById("h").style.background = '#FF0000';

  if(levelEasy == true)
  {
    for(var i = 6; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
    }
    levelEasy = false;
  }
  else if (levelMedium == true)
  {
    for(var i = 11; i <19; i++)
    {
      var c = document.getElementById("palette" + i);
      c.style.display = "unset";
    }
    levelMedium = false;
  }
}

/**************************************************************************************
FUNCTION PURPOSE: Display uploaded image on canvas
PARMATERS: none
REFRENCES: https://www.w3schools.com/html/html5_canvas.asp
***************************************************************************************/
function putPicOnCanvas()
{ 
  //get our image from html and store it in pic
  var pic = new Image();
  var pic = document.getElementById("output");

  //get the picture's dimentions 
  var w = pic.width || pic.naturalWidth; 
  var h = pic.height || pic.naturalHeight;

  //refrence our canvas and canvas context from html
  var canvas = document.getElementById('canvas_one'); 
  var context = canvas.getContext('2d');

  //get canvas dimentions
  canvas.width = w; 
  canvas.height = h;

  //paste our image on our canvas
  context.drawImage(pic, 0, 0, w, h); 

  //CODE BELOW IS FOR OUR PALETTE CANVASES

  var i;

  for(i = 1; i <= colorLimit; i++) //only have as many as our limit
  {
    //get canvases and context
    var c = document.getElementById("palette" + i);
    var cContext = c.getContext("2d");

    //see if our browser allows for an eyedropper tool 
    if ('EyeDropper' in window) {
      //add an onclick to the palette canvases 
      c.addEventListener('click', pickColor); 
    }
    //fill canvas with grey, outline in black 
    cContext.fillStyle = "#dcdcdc"; //grey
    cContext.strokeStyle = "#000000"; //black
    cContext.fillRect(0,0, c.width, c.height);
    cContext.strokeRect(0,0, c.width, c.height);
  }
}

function test()
{
  if (numColors < 2)
  {
    alert("You must pick at least two colors for your palette");
  }
  else
  {
    loadPic();
  }
}

/**************************************************************************************
FUNCTION PURPOSE: This function operates as my main function. All the adjustments to the 
  picture are called within this function
PARMATERS: none
***************************************************************************************/
function loadPic() 
{
    
    //get our image from html and store it in pic
    var pic = new Image(); 
    var pic = document.getElementById("output"); 

    //get dimentions of pic
    var width = pic.width || pic.naturalWidth; 
    var height = pic.height || pic.naturalHeight;

    //get my canvas from HTML
    var canvas = document.getElementById('canvas_one'); 
    var context = canvas.getContext('2d');

    //adjust using pics dimentions
    w = canvas.width = width; 
    h = canvas.height = height;

    //draw pic onto canvas... necessary for getImageData down below
    context.drawImage(pic, 0, 0, width, height); 

    //this gets the data from the canvas and stores it as numbers in imageData
    //Image data is an array that has four indexs for each pixel representing colors
    imageData = context.getImageData(0, 0, width, height); 
    
    //make average palette
    //window.open('generate/index.html');
    var rgb = {r:0, g:0, b:0};

    for(var i = 0; i < palette.length; i++)
    {
      let clone = {};
       clone.r = rgb.r;
       clone.g = rgb.g;
       clone.b = rgb.b;
      paletteUpdate[i] = clone; //all get empty rgb value
    }

    //kMeans function (take distance between paltette colors and all pixels and save the smallest (closest))
    var paletteImageData = context.createImageData(imageData.width, imageData.height); 
    
    paletteImageData = kMeans(imageData, palette); //holds updated image data



    //updatePalette(paletteMatrix, imageData); //here
    //think of function for right here that goes through each region (comparing image 
    //data to our paletteMatrix) and generates the average of that region, and 
    //creates a new palette (would not need to change palette Matrix)

  // var updatedPaletteMatrix = kMeans(paletteImageData, palette); //holds last round of updated image data THIS

    //this finds the regions large enough to hold number labels, and finds the center of these regions and holds the x and y values (represting pixel location)
    //var labelLocations  = findLabelRegions(updatedPaletteMatrix);  //THIS

    //var labelLocations  = findLabelRegions(paletteImageData);  //slow as shit... might not work (Put in on click, 
    //wive numbers)
  
    //var oLine = outline(updatedPaletteMatrix); //THIS Image data
    // var oLine = outline(paletteImageData);

    //  var finalColors = [{ r: 255, g: 255, b: 255 }, //white //THIS
    //  { r: 150, g: 150, b: 150 }]; //grey //THIS 

    // var blackWhiteImgData = matrixToImageData(oLine, finalColors, context); //THIS 

  //need final function 

  context.putImageData(paletteImageData, 0, 0);

  // for (var i = 0; i < labelLocations.length; i++) {
  //   console.log(labelLocations[i].x);
  //   console.log(labelLocations[i].y);
  // }

  //context.putImageData(paletteImageData, 0, 0);

  //context.strokeStyle = "#000000";
  //context.strokeRect(0,0, canvas.width, canvas.height);
  // // draw numbers
  // context.font = "12px Georgia";
  // context.fillStyle = "rgb(150, 150, 150)";
  // for (var i = 0; i < labelLocations.length; i++) {
  //     context.fillText(labelLocations[i].value + 1,
  //     labelLocations[i].x - 3,
  //     labelLocations[i].y + 4);
  //}

    // let goBack = document.createElement('button');
    // goBack.innerHTML = 'Back';
    // goBack.disabled = true;
    // //disable

    //origional - uplaoded photo
    //add numbers
    //paint by number



   let refine = document.createElement('button');
   refine.innerHTML = 'Refine'; 
   refine.onclick = function() { 

    paletteImageData = kMeans(paletteImageData , paletteUpdate);
    context.putImageData(paletteImageData, 0, 0);
    firstTime = false;

   }
   document.body.appendChild(refine);

   let paintByNum = document.createElement('button');
   paintByNum.innerHTML = 'View Paint By Number'; 
   paintByNum.onclick = function() { 

    if(firstTime)
    {
      var labelLocations  = findLabelRegions(paletteImageData, palette); 
    }
    else
    {
      var labelLocations  = findLabelRegions(paletteImageData, paletteUpdate); 
    }
  //     for (var i = 0; i < labelLocations.length; i++) {
  //     context.fillText(labelLocations[i].value + 1,
  //     labelLocations[i].x - 3,
  //     labelLocations[i].y + 4);
  // }

  //   for (var i = 0; i < labelLocations.length; i++) {
  //   console.log(labelLocations[i].x);
  //   console.log(labelLocations[i].y);
  // }

    var oLine = outline(paletteImageData);

     var finalColors = [{ r: 255, g: 255, b: 255 }, //white //THIS
     { r: 150, g: 150, b: 150 }]; //grey //THIS 

     //have to make oLine into image data
    var blackWhiteImgData = matrixToImageData(oLine, finalColors, context); //THIS 

    context.putImageData(blackWhiteImgData, 0, 0);

    context.strokeStyle = "#000000";
    context.strokeRect(0,0, canvas.width, canvas.height);
        // // draw numbers
        context.font = "12px Georgia";
        context.fillStyle = "rgb(150, 150, 150)";
        for(var e = 0; e < palette.length; e++)//have to send it palette to see which val it gets
        { 
          if(firstTime)
          {
            if(palette[e].r == labelLocations[e].value.r && palette[e].g == labelLocations[e].value.g && palette[e].b == labelLocations[e].value.b)
              labelLocations[i].num = e+1; //value is the pixel at the point it was called (figure out imagedata)
          }
          else
          {
            if(paletteUpdate[e].r == labelLocations[e].value.r && paletteUpdate[e].g == labelLocations[e].value.g && paletteUpdate[e].b == labelLocations[e].value.b)
            labelLocations[i].num = e+1; //value is the pixel at the point it was called (figure out imagedata)
          } //the num thing doesn't work
        }

        for (var i = 0; i < labelLocations.length; i++) {
          //console.log(labelLocations[i].value.r);
            context.fillText(labelLocations[i].value + 1,
            labelLocations[i].x - 3,
            labelLocations[i].y + 4);
        }

   }

   document.body.appendChild(paintByNum);

   let seeFinal = document.createElement('button');
   seeFinal.innerHTML = 'See Finished';
   seeFinal.onclick = function() { 
     //var igData = generateFinal(paletteMatrix, oLine, context, palette);
     context.putImageData(paletteImageData, 0, 0);
      //goBack.disabled = false;
      seeFinal.disabled = true;
      //disable seeFinal
      //enable goBack
   }
   document.body.appendChild(seeFinal);
  // document.body.appendChild(goBack);


  //  goBack.onclick = function() {
  //     goBack.disabled = true;
  //     seeFinal.disabled = false;

  //     context.putImageData(imgData, 0, 0);

  //     context.strokeStyle = "#000000";
  //     context.strokeRect(0,0, canvas.width, canvas.height);
  //     // // draw numbers
  //     context.font = "12px Georgia"; //change font size accoring to level
  //     context.fillStyle = "rgb(150, 150, 150)";
  //     for (var i = 0; i < labelLocations.length; i++) {
  //         context.fillText(labelLocations[i].value + 1,
  //         labelLocations[i].x - 3,
  //         labelLocations[i].y + 4);
  //     }
  //  }
  //create button to print, or save and go back
  //to go back... should just be abple to put imgData on canvas again?
  //with the outline and numbers drawn??? because we don't change img Fata
  //disable generate button 
}

function updatePalette(paletteMatrix, imageData)
{
  var width = paletteMatrix[0].length;
  var height = paletteMatrix.length;
  //get all numbers in palette Matrix (use that function)
  var red; 
  var green;
  var blue; 

  //var paletteColor;

  for(var i = 0; i < palette.length; i++)
  {
    //paletteColor = i; 
    var numPixel = 0;
    //var firstTime = true;
    var rgb = {r:0, g:0, b:0};

    for (var y = 0; y < height; y++) 
    {
      for (var x = 0; x < width; x++) 
      {
        if(paletteMatrix[y][x] == i)
        {
      
          // {
            numPixel++;
            //gets position in image data
            var t = (y * width + x) * 4; 
            rgb.r += imageData.data[t]; 
            rgb.g += imageData.data[t+1];
            rgb.b += imageData.data[t+2];

           
        }
      } 
    }

    rgb.r = Math.floor(rgb.r/numPixel); //FLOOR
    rgb.g = Math.floor(rgb.g/numPixel);
    rgb.b = Math.floor(rgb.b/numPixel);


    palette[i] = rgb;

    //go through paletteMatrix and find all i's
    //At each one, convert x,y values to image data and get the rgb values 

  }

  //for that region, add up the reds, the greens and the blues and  make an average color
  //update palette
}

function generateFinal(paletteMatrix, oLine, context, palette)
{
  var gMatrix = _.cloneDeep(paletteMatrix);

  var width = oLine[0].length;
  var height = oLine.length;

   //go through and compate to outline matrix. If in outline matrix, it is a 1, make that black (or our grey color)
  // for (var y = 0; y < height; y++) 
  // {
  //   for (var x = 0; x < width; x++) 
  //   {
  //     if(oLine[y][x] == 1)
  //     {
  //       gMatrix[y][x] = 100; // 100 will signify where we need to draw the lines
  //     }
  //   }
  // }

  var imageData = context.createImageData(gMatrix[0].length, gMatrix.length); // try oLine

  for(var y = 0; y < gMatrix.length; y++)
  {
    for (var x = 0; x < gMatrix[0].length; x++)
    {
      var i = (y * gMatrix[0].length + x) * 4; 

      if (gMatrix[y][x] == 100)
      {
        imageData.data[i] = 0;
        imageData.data[i+1] = 0;
        imageData.data[i+2] = 0;
        imageData.data[i+3] = 255; //guess from previous imageData
      }
      else //not sure if the -1 is right...
      {
        var color = palette[gMatrix[y][x]];

        imageData.data[i] = color.r; // palette 0 is color 1
        imageData.data[i+1] = color.g;
        imageData.data[i+2] = color.b;
        imageData.data[i+3] = 255; //guess from previous imageData
      }
    }
  }

  return imageData;
  //make image data from the gMatrix 
}

/**************************************************************************************
FUNCTION PURPOSE: Convert Matrix of closest palette colors to ImageData
PARMATERS: The line (where the outline will be), our two end colors (white background, black
  lines) and the canvas context
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function matrixToImageData(ol, fc, ctx) //outline, final colors, context of canvas
{
  //create ImageData based off of size of our outline matrix (also size of palette matrix)
  var imageData = ctx.createImageData(ol[0].length, ol.length); //make new image data for this...
  
  for(var y = 0; y < ol.length; y++)
  {
    for (var x = 0; x < ol[0].length; x++)
    { 
      //because each pixel four spaces, have to multiply by 4, and add x because
      //ImageData is not a matrix but an array
      var i = (y * ol[0].length + x) * 4; 
      //determines where the pixel will be black or white
      var column = fc[ol[y][x]];
      imageData.data[i] = column.r;
      imageData.data[i+1] = column.g;
      imageData.data[i+2] = column.b;
      imageData.data[i+3] = 255;
    }
  }
  return imageData;
}

/**************************************************************************************
FUNCTION PURPOSE: Create a matrix that holds which palette color each pixel is closest to
PARMATERS: Image data and our palette array
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function kMeans(functionImageData, functionPalette) //want to update palette in this function as we go....
{
    // for(var i = 0; i < functionPalette.length; i++)
    // {
    //   console.log("functionPalette.r before: " + functionPalette[i].r);
    //   console.log("functionPalette.g before : " + functionPalette[i].g);
    //   console.log("functionPalette.b before: " + functionPalette[i].b);
    // }

    // console.log("functionImageData: " + functionImageData.data[0]);
    // console.log("functionImageData: " + functionImageData.data[1]);
    // console.log("functionImageData: " + functionImageData.data[2]);

  //make new image data- copy in old image data, then adjust that (before/after)


//make an array of variables to hold the color averages....
  var colorAvg = [];
  var colorCount = [];
  var testCount = 0;
  var rgb = {r:0, g:0, b:0};
  //colorAvg[0] should be palette[0].r (or all nearest to palette[0])
  for(var p = 0; p <functionPalette.length * 3; p++)
  {
    colorAvg[p] = 0;
  }

  for(var c = 0; c < functionPalette.length; c++)
  {
    colorCount[c] = 0;
  }


  //compare every other?? Every three (Could make it increase by 8! nearest Matrix[y][x] and Matrix[y][x+1] can get same (look up way image data goes))
  for(var i =4; i < imageData.data.length; i += 12) //must increase i by four because imagedata has four spots for each pixel(r,g,b,a)
  {
    // console.log("There:" + imageData.data[i]);
    // console.log("There:" + imageData.data[i+1]);
    // console.log("There:" + imageData.data[i+2]);
    //call getNearest and send it the palette and the color data in the pixel
    // if(testCount < 5)
    // {
    //   for(var j = 0; j < functionPalette.length; j++)
    //   {
    //     console.log("functionPalette.r: " + functionPalette[j].r);
    //     console.log("functionPalette.g: " + functionPalette[j].g);
    //     console.log("functionPalette.b: " + functionPalette[j].b);
    //   }
    //   testCount++; 
    // }

    var closestColor = getClosest(functionPalette, {
      r:functionImageData.data[i],
      g:functionImageData.data[i+1],
      b:functionImageData.data[i+2]
    });

    //console.log("ClosestColor: " + closestColor);
    colorCount[closestColor]++;
    //console.log("ClosestColor: " + closestColor);
    //console.log("colorCount[closestColor]: " + colorCount[closestColor]);

    var loc = closestColor * 3; 
    colorAvg[loc] = colorAvg[loc] + functionImageData.data[i]; //
    colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[i+1];
    colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[i+2]; //stoppe dher 
    

    //maybe make a bool that changes on the second run through and lets us set nearest....

    // console.log("functionImageData 1: " + functionImageData.data[i]);
    // console.log("functionImageData 1: " + functionImageData.data[i+1]);
    // console.log("functionImageData 1: " + functionImageData.data[i+2]);


    // console.log("Closest Color: " + closestColor);
    // console.log("functionPalette[closestColor].r: " + functionPalette[closestColor].r);
    // console.log("functionPalette[closestColor].g: " + functionPalette[closestColor].g);
    // console.log("functionPalette[closestColor].b: " + functionPalette[closestColor].b);
    functionImageData.data[i] = functionPalette[closestColor].r; 
    functionImageData.data[i+1] = functionPalette[closestColor].g; 
    functionImageData.data[i+2] = functionPalette[closestColor].b; 

    // console.log("functionImageData 2: " + functionImageData.data[i]);
    // console.log("functionImageData 2: " + functionImageData.data[i+1]);
    // console.log("functionImageData 2: " + functionImageData.data[i+2]);
    

    //take i/4 because each pixel holds four elements in the array for r,g,b,a
    var x = (i/4) % functionImageData.width; //determines row (%imageData.width keeps within matrix size)

    var y = Math.floor((i/4)/functionImageData.width); //determine column (should increase less frequently than row...)

    //holds which palette color is closest to this pixel, where y represnts pixel in relation to height 
    //and x represnts pixel in relation to width
    // nearestMatrix[y][x] = closestColor; 

    var j = i + 4;
    var k = i - 4;
    if(Math.floor((j/4)/functionImageData.width) == y && Math.floor((k/4)/functionImageData.width) == y )//if increasing/decreasing the x value does not change the y value (does not go to new colum)
    {
      colorCount[closestColor]++;
      //var loc = closestColor * 3; 
      //console.log("ClosestColor: " + closestColor);
      //console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      colorAvg[loc] = colorAvg[loc] + functionImageData.data[k]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] +functionImageData.data[k+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[k+2]; 

      functionImageData.data[k] = functionPalette[closestColor].r; 
      functionImageData.data[k+1] = functionPalette[closestColor].g; 
      functionImageData.data[k+2] = functionPalette[closestColor].b; 

    //  nearestMatrix[y][x-1] = closestColor; 
    //  nearestMatrix[y][x+1] = closestColor; 

      colorCount[closestColor]++;

      //console.log("ClosestColor: " + closestColor);
      //console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      //var loc = closestColor * 3; 
      colorAvg[loc] = colorAvg[loc] + functionImageData.data[j]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[j+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[j+2]; //stoppe dher 

      functionImageData.data[j] = functionPalette[closestColor].r; 
      functionImageData.data[j+1] = functionPalette[closestColor].g; 
      functionImageData.data[j+2] = functionPalette[closestColor].b; 
    }
    else if(Math.floor((j/4)/functionImageData.width) == y ) //if decreasing changes column but increaing does not
    {
      //nearestMatrix[y][x+1] = closestColor; 

      colorCount[closestColor]++;
      //console.log("ClosestColor: " + closestColor);
      //console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      
      colorAvg[loc] = colorAvg[loc] + functionImageData.data[j]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[j+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[j+2];

      functionImageData.data[j] = functionPalette[closestColor].r; 
      functionImageData.data[j+1] = functionPalette[closestColor].g; 
      functionImageData.data[j+2] = functionPalette[closestColor].b;

      var closestColor = getClosest(functionPalette, { //calculate closest for k
        r:functionImageData.data[k],
        g:functionImageData.data[k+1],
        b:functionImageData.data[k+2]
      });

      //var x = (k/4) % imageData.width; //determines row (%imageData.width keeps within matrix size)

      //var y = Math.floor((k/4)/imageData.width); //determine column (should increase less frequently than row...)

      //nearestMatrix[y][x] = closestColor; 

      colorCount[closestColor]++;
      //console.log("ClosestColor: " + closestColor);
      //console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      loc = closestColor * 3; 
      colorAvg[loc] = colorAvg[loc] + functionImageData.data[k]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[k+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[k+2];

      functionImageData.data[k] = functionPalette[closestColor].r; 
      functionImageData.data[k+1] = functionPalette[closestColor].g; 
      functionImageData.data[k+2] = functionPalette[closestColor].b; 

    }
    else if(Math.floor((k/4)/functionImageData.width) == y)
    {

      //nearestMatrix[y][x-1] = closestColor; 

      colorCount[closestColor]++;

     // console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      colorAvg[loc] = colorAvg[loc] + functionImageData.data[k]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[k+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[k+2];

      functionImageData.data[k] = functionPalette[closestColor].r; 
      functionImageData.data[k+1] = functionPalette[closestColor].g; 
      functionImageData.data[k+2] = functionPalette[closestColor].b; 

      var closestColor = getClosest(functionPalette, { //calculate closet for j
        r:functionImageData.data[j],
        g:functionImageData.data[j+1],
        b:functionImageData.data[j+2]
      });

      //var x = (j/4) % imageData.width; //determines row (%imageData.width keeps within matrix size)

      //var y = Math.floor((j/4)/imageData.width); //determine column (should increase less frequently than row...)

      //nearestMatrix[y][x] = closestColor; 
      colorCount[closestColor]++;
      //console.log("ClosestColor: " + closestColor);
      //console.log("colorCount[closestColor]: " + colorCount[closestColor]);
      loc = closestColor * 3; 

      colorAvg[loc] = colorAvg[loc] + functionImageData.data[j]; //the r value... may need .r
      colorAvg[loc + 1] = colorAvg[loc+1] + functionImageData.data[j+1];
      colorAvg[loc + 2] = colorAvg[loc + 2] + functionImageData.data[j+2];

      functionImageData.data[j] = functionPalette[closestColor].r; 
      functionImageData.data[j+1] = functionPalette[closestColor].g; 
      functionImageData.data[j+2] = functionPalette[closestColor].b; 
    }
  }
 

   // console.log("In if....... ");

    var increment = 0;
    for(var n = 0; n < colorAvg.length; n++)
    {
      if(n%3 == 0 && n != 0) //increment should change wnen n% 3 = 0 so we get new palette color
      {
        increment ++; 
      }
      // console.log("N: " + n + " ColorAvg: " + colorAvg[n]);
      // console.log("N: " + n + " increment: " + increment+ " ColorCount: " + colorCount[increment]);
      colorAvg[n] = Math.floor(colorAvg[n]/colorCount[increment]); //should hold average of all our colors
    }
  
 
    var paletteCount = 0;
    for(var l = 0; l < colorAvg.length; l += 3)
    {
      //var rgb = {r:0, g:0, b:0};
       rgb.r = colorAvg[l];
       //console.log("rgb.r: " + rgb.r);
       rgb.g = colorAvg[l+1];
      // console.log("rgb.g: " + rgb.g);
       rgb.b = colorAvg[l+2];
       //console.log("rgb.b: " + rgb.b);

       let clone = {};
       clone.r = rgb.r;
       clone.g = rgb.g;
       clone.b = rgb.b;
       paletteUpdate[paletteCount] = clone;
       

      //console.log("palette count" + paletteCount);

      paletteCount++;
    }
    
  
  return functionImageData; //not sure if this is how refrence works....
}

/**************************************************************************************
FUNCTION PURPOSE: Finds which palette color a pixel is closet to
PARAMATERS: Palette array and the color of the pixel we are looking at
REFRENCES: https://medium.com/geekculture/implementing-k-means-clustering-from-scratch-in-javascript-13d71fbcb31e
***************************************************************************************/
function getClosest(functionPalette, color) 
{
//function palette is getting sent in as 0s
  // for(var i = 0; i < functionPalette.length; i++)
  // {
  //   console.log("functionPalette.r: " + functionPalette[i].r);
  //   console.log("functionPalette.g: " + functionPalette[i].g);
  //   console.log("functionPalette.b: " + functionPalette[i].b);
  // }
//   console.log("Here:" + color.r);
//   console.log("Here:" + color.g);
//   console.log("Here:" + color.b);
  var closestColor, closestColorIndex, prevDistance;
  //var colorHSV = RgbToHsv(color.r, color.g, color.b);
  for(var i = 0; i < functionPalette.length; i++) //cycle through palette
  {
    var currentColor = functionPalette[i]; //get the current color to compare to
    if(i == 0)
    {
      closestColor = currentColor;
      closestColorIndex = i; 

      prevDistance = ((closestColor.r - color.r) ** 2) + 
        ((closestColor.g - color.g) ** 2) +
        ((closestColor.b - color.b) ** 2); 

    }  
    else
    {

      var distance = ((currentColor.r - color.r) ** 2) + 
      ((currentColor.g - color.g) ** 2) +
      ((currentColor.b - color.b) ** 2); 
    
      
      if(distance < prevDistance) //if this color is closer in clolor to this colot than the ones we previously checked 
      {
          prevDistance = distance;
          closestColor = color;
          closestColorIndex = i;
      }
    }

  }
  //console.log("closestColorIndex: " + closestColorIndex);
  return closestColorIndex;
}

/**************************************************************************************
FUNCTION PURPOSE: find the regions that will need labels (gets rid of small regions)
PARMATERS: the matrix that holds which palette color each pixel is closest to
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/

function findLabelRegions(igData, functionPalette)
{
  //IDEA FOR ADJUSTMENT: GET RGB OF EACH IMAGE DATA, COMPARE TO PALETTE LOC

  var width = imageData.width; //number of columns in row 0 of matrix
  var height = imageData.height; //number of rows

  //console.log("Width: " + width);
  //console.log("height: " + height);

  var covered = [];

  for (var i = 0; i < height; i++) //through number of rows
  {
    covered[i] = new Array(width); // for each element of the array, make a new array of length width (#cols in row 0 of matrix)
    _.fill(covered[i],false); //fills covered array with all false values
  }

  var labelLocs = []; 

  for (var y = 0; y < height; y++)  //rows
  {
    for (var x = 0; x < width; x++) //columns
    {
      if (covered[y][x] == false) //if we have not yet checked this pixel
      {
        //find all near pixels that share the same palette color
        var region = getRegion(igData, covered, x, y, functionPalette); //this must be what is confusing it

        // for(var i = 0; i < region.x.length; i++)
        // {
        //   console.log("getRegion x:" + region.x[i]);
        //   console.log("getRegion y:" + region.y[i]);
        // }

        //region.x holds all the x values for the pixels with same palette color (length same as region.y.length)
        for(var i = 0; i < region.x.length; i++) 
        { 
          covered[region.y[i]][region.x[i]] = true; //mark true all that share same palette color
        }
      
        //checks to make sure we're not labeling very small regions
        if(region.x.length > 100) 
        {
          labelLocs.push(getLabelPlacement(igData,region));//find where the label will go 
          //or this.... 
        }
        else //if the region is not big enough...
        {
          //remove the region
          
          if(region.y[0] > 0) 
          {
            //choose the palette color of the pixel to the left
            var c = ((region.y[0] - 1) * covered[0].length + region.x[0]) * 4; 
            var newColor = {r: 0, g:0, b:0};
            newColor.r = igData.data[c];
            newColor.g = igData.data[c + 1];
            newColor.b = igData.data[c + 2];
            //matrix[region.y[0] - 1][region.x[0]];  //get imsgedata from this part
          }
          else
          {
            var xx = region.x[0];
            var yy = region.y[0];
            
            var c = (yy * covered[0].length + xx) * 4; 

            //while(matrix[yy][xx] == region.value)
            while(igData.data[c] == region.value.r && igData.data[c+1] == region.value.g && igData.data[c+2] == region.value.b)
            {
              yy++;
            }
            var newColor = {r:0, g:0 , b:0};
            newColor.r = igData.data[c];
            newColor.g = igData.data[c + 1];
            newColor.b = igData.data[c + 2];
            // matrix [yy][xx];
          }
          
          //for our entire small region...
          for(var i = 0; i < region.x.length; i++)
          {
            //assign a new color from the palette (one of the near by colors)
            var l = (region.y[i] * covered[0].length + region.x[i]) * 4; 
            newColor.r = igData.data[l];
            newColor.g = igData.data[l + 1];
            newColor.b = igData.data[l + 2];
            //matrix[region.y[i]][region.x[i]] = newColor;
          } 
        }
      }
    }
  }

  // for(var i = 0; i < labelLocs.length; i++)
  // {
  //   console.log("LabelLocs" + labelLocs[i].x);
  //   console.log("LabelLocs" + labelLocs[i].y);
  // }

 return labelLocs; //return the locations of where the labels will be placed
}

/**************************************************************************************
FUNCTION PURPOSE: find how far the specific region with [y][x] spans
PARMATERS: the matrix that holds which palette color each pixel is closest to, the covered
  matrix that holds false values (if a pixel gets marked true, it is in the region) and our
  x and y value
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
var getRegion = function(imgData, cov, x, y, functionPalette) //function to find the regions 
{

  var covered = _.cloneDeep(cov); //recursively clones cov matrix

  //value holds our current pixel, and x and y are empty arrays that will hold the 
  //x and y values in the region
  var i = (y * cov[0].length + x) * 4; 
  var rgb = {r:0, g:0, b:0};
  rgb.r = imgData.data[i];
  rgb.g = imgData.data[i+1];
  rgb.b = imgData.data[i+2];

  var clone = {r:0, g:0, b:0};

  //console.log("i: " + i);
  // console.log("Outside ImageData: " + imgData.data[i]);
  // console.log("Outside ImageData: " + imgData.data[i+1]);
  // console.log("Outside ImageData: " + imgData.data[i+2]);
  
  var region = { num: 0, value: rgb, x: [] , y: [] };  //value will only hold red val.... 

  // for(var e = 0; e < functionPalette.length; e++)//have to send it palette to see which val it gets
  // {
  //   if(functionPalette[e].r == rgb.r && functionPalette[e].g == rgb.g && functionPalette[e].b == rgb.b)
  //     var value = e+1; //value is the pixel at the point it was called (figure out imagedata)
  // }
  var value = rgb;
  var val = rgb;
 
  var queue = [[x,y]]; //array of coordinants that will hold the pixels connected with same palette color

  while(queue.length>0)
  {
    var coord = queue.shift(); //shift removes first element of array (coord holds first element)

    //if the current pixel we're looking at has not yet been visited, and if it has has the same pixel value
    var p = (coord[1]* cov[0].length + coord[0]) * 4; 
    clone.r = imgData.data[p];
    clone.g = imgData.data[p+1];
    clone.b = imgData.data[p+2];

    //console.log("p: " + p);
    //  console.log("Inside ImageData: " + imgData.data[p]);
    //  console.log("Inside ImageData: " + imgData.data[p+1]);
    //  console.log("Inside ImageData: " + imgData.data[p+2]);

    if (covered[coord[1]][coord[0]] == false && clone.r == val.r && clone.g == val.g && clone.b == val.b) 
    {
      //console.log("In this if again"); 

      region.x.push(coord[0]); //put coord[0](x) in the x array of region
      region.y.push(coord[1]); //put coord[1](y) in the y array of region
      covered[coord[1]][coord[0]] = true; //mark those values as true in covered matrix

      if (coord[0] > 0) //if the x coordinant is 0
      {
        queue.push([coord[0] - 1, coord[1]]); //put the pixel to the left in the queue to check
      }
      //have to change this.... width
      if (coord[0] < imgData.width- 1) //put pixel to the right in the queue to check
      {
        queue.push([coord[0]+1, coord[1]]); 
      }

      //same thing for y 
      if (coord[1] > 0) 
      {
        queue.push([coord[0], coord[1]-1]);
      }

      if (coord[1] < imgData.height-1)
      {
        queue.push([coord[0], coord[1] + 1]);
      }
    }
  }
  //once finished, return our found region
  return region; 
}

/**************************************************************************************
FUNCTION PURPOSE: find the best space in our regions to place our labels
PARMATERS: the matrix that holds which palette color each pixel is closest to, and the region
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function getLabelPlacement(iData, region)
{
  var bestI = 0;
  var best = 0;
  
  //region.x holds all the x values in the region. Region.x.length and region.y.length are the same
  for (var i = 0; i < region.x.length; i++) 
  {
    //calculate possible placements (moving in all directions)
    var goodness = labelTester(iData, region.x[i], region.y[i], -1, 0) * 
      labelTester(iData, region.x[i], region.y[i], 1, 0) *
      labelTester(iData, region.x[i], region.y[i], 0, -1) *
      labelTester(iData, region.x[i], region.y[i], 0, 1);

      //determine the best
      if(goodness > best)
      {
        best = goodness;
        bestI = i;
      }
  }
  //return bestI as a region object
  return {
    num: 0,
    value: region.value,
    x: region.x[bestI], //returns the x value of the best found placement
    y: region.y[bestI]  //returns the y value of the best found placement
  };
}

/**************************************************************************************
FUNCTION PURPOSE: finds a space for our number label. This is called in getLabelPlacement
PARMATERS: the matrix that holds which palette color each pixel is closest to, the x and
  y value of our pixel, and then the numbers we want to increase our x and y values by
  (incX, incY)
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function labelTester(iData, x, y, incX, incY)
{
  //var value = matrix[y][x];
  var i = (y * imageData.width + x) * 4; 
  var rgb = {r:0, g:0, b:0};
  rgb.r = iData.data[i];
  rgb.b = iData.data[i+1];
  rgb.g = iData.data[i+2];
  var value = rgb;

  // console.log("Rgb in labelTester (r): " + rgb.r); //all the same
  // console.log("Rgb in labelTester (g): " + rgb.g);
  // console.log("Rgb in labelTester (b): " + rgb.b);
  //get color from this position (simialt code above.... )
  var count = -1;

  //while x is greater than 0 and x < number of columns in row 0 of matrix and 
  //y is greater than 0 and y is less than the number or rows 
  //and the value in our matrix array hasn't changed 

  var temp = value; 
  //don't think it ever goes in here... temp isnt equal to val at forst
  while( x>= 0 && x < imageData.width && y >= 0 && y < imageData.height && temp == value) //change to image width and height
  {
   count++;
   x += incX; //move in our sent in directions
   y += incY; 

   i = (y * imageData.width + x) * 4; 
   rgb.r = iData[i];
   rgb.b = iData[i+1];
   rgb.g = iData[i+2];
   var temp = rgb;
  }

  return count; //return the amount of space the current run through has found
}

/**************************************************************************************
FUNCTION PURPOSE: Identifies where the outline will be
PARMATERS: the matrix that holds which palette color each pixel is closest to
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function outline(imgData)  
{
  var width = imgData.width; //right
  var height = imgData.height;

  var line = [];

  //make line a matrix (same saize as our mat matrix (the matrix that holds palette colors))
  for (var i = 0; i < height; i++) 
  {
    line[i] = new Array(width);
  }
//GHERE
  for (var y = 0; y < height; y++) 
  {
    for (var x = 0; x < width; x++) 
    {

      // var l = (y * width + x) * 4; 
      // console.log("imgData.data[i]: " + imgData.data[l]);
      // console.log("imgData.data[i +1]: " + imgData.data[l +1]);
      // console.log("imgData.data[i +2 ] " + imgData.data[l +2]);
      //true means next pixel shares palette color
      if(neighborsSame(imgData, x, y, line) == true) 
      {
        //this will be a region so it does not get a line
        line[y][x] = 0;
        //console.log("I'm in here with the zero"); //does this once
      } 
      else //next pixel does not share palette color
      {
        //this will not be a region, so it gets a line
        line[y][x] = 1;
        //console.log("I'm in here with the one"); //does this all other times
      } 
    }
  }

  // for(var e = 0; e < height/4; e++)
  // {
  //   for(var m = 0; m < width/4; x++)
  //   {
  //     console.log("Line array: " + line[e][m]);
  //   }
  // }

  //return our line matrix, which will hold a 1 of there should be a line, and a 0 if there shouldn't be
  return line;
}

/**************************************************************************************
FUNCTION PURPOSE: Looks at a sent in pixel and determines if nearby pixels share the same
  palette color. This will help us create our outline, because if two near pixels have
  different colors, they should be seperated by a line
PARMATERS: Matrix that holds palette colors, and the x and y value of the current pixel
REFRENCES: https://github.com/daniel-munro/pbnify
***************************************************************************************/
function neighborsSame(imgData, x, y, line) 
{
//something is sent in 
    //  console.log("imgData.data[0]: " + imgData.data[0]);
    //  console.log("imgData.data[1]: " + imgData.data[1]);
    //  console.log("imgData.data[2 ] " + imgData.data[2]);

  var width = imgData.width;
  var height = imgData.height;

  //holds current pixel color (closest to palette)
  
  //RGB stuff... oof
  var i = (y * line[0].length + x) * 4; 


  //  console.log("imgData.data[i]: " + imgData.data[i]);
  //  console.log("imgData.data[i +1]: " + imgData.data[i +1]);
  //  console.log("imgData.data[i +2 ] " + imgData.data[i +2]);
  //console.log("i: " + i);
  var rgb = {r:0, g:0, b:0};

  //   console.log("val.r: " + rgb.r);
  //  console.log("val.g: " + rgb.g);
  //  console.log("val.b: " + rgb.b);

  // let clone = {};
  //   clone.r = mat[i];
  //   clone.g = mat[i+1];
  //   clone.b =  mat[i+2];
  
  //thid gets nothing


  //  console.log("imgData.data[i]: " + imgData.data[i]);
  //  console.log("imgData.data[i +1]: " + imgData.data[i +1]);
  //  console.log("imgData.data[i +2 ] " + imgData.data[i +2]);

  rgb.r = imgData.data[i];  //these are my problems
  rgb.b = imgData.data[i+1];
  rgb.g = imgData.data[i+2];

  var val = rgb;
  var xRel = [1, 0];
  var yRel = [0, 1];

  //  console.log("val.r: " + rgb.r);
  //  console.log("val.g: " + rgb.g);
  //  console.log("val.b: " + rgb.b);

  //xRel.length = 2
  for (var n = 0; n < xRel.length; n++)  //i +=4
  {
    //increase either x or y by 1 (move to the next pixel)
    var xx = x + xRel[n];
    var yy = y + yRel[n];

    if (xx >= 0 && xx < width && yy >= 0 && yy < height) //doesnt gp in here
    {
      //if this next pixel does not share a palette colore
      //console.log("In this iff");
      i = (yy * line[0].length + xx) * 4; 
      let clone = {};
      clone.r = imgData.data[i];
      clone.b = imgData.data[i+1];
      clone.g = imgData.data[i+2];
      var temp = clone; //don't want to use rgb twice
      // console.log("temp.r: " + temp.r);
      // console.log("temp.g: " + temp.g);
      // console.log("temp.b: " + temp.b);
      // if (temp != val) 
      // {
      //   return false;
      // }
      if (temp.r != val.r && temp.g != val.g && temp.b != val.b) 
      {
        return false;
      }
    }
  }
  //next pixel does share a palette colore
  return true;
}

/**************************************************************************************
FUNCTION PURPOSE: Opens Eye Dropper on palette canvas onclick
PARMATERS: none
REFRENCES:  https://dev.to/madsstoumann/introducing-the-eyedropper-api-14d7
***************************************************************************************/
async function pickColor() 
{
  //creates new eyedropper Object
  const ED = new EyeDropper();
  const result = await ED.open();

  //increase the number of colors
  numColors ++; 

  //if exceeding the color limit
  if(numColors > colorLimit)
  {
    numColors--;
    alert("You have exceeded the number of colors");  //alert
  }
  else
  {
    //get palette currently on
    var c = document.getElementById("palette" + numColors);
    //get the context of the palette
    var cContext = c.getContext("2d");
    //outine around palette box
    cContext.strokeStyle = "#000000";
    //set new color to fill(choosen by eyedropper)
    cContext.fillStyle = result.sRGBHex; 
    //store current color in palette array (hexToRgb converts them to rgb values)
    palette[numColors-1] = hexToRgb(result.sRGBHex); 
    paletteHSV[numColors -1] = RgbToHsv(palette[numColors-1].r, palette[numColors-1].g, palette[numColors-1].b);
    //fill palette with new color
    cContext.fillRect(0,0, c.width, c.height);
    //black outline
    cContext.strokeRect(0,0, c.width, c.height);
    if(palette[numColors-1].r < 100 && palette[numColors-1].g < 100 && palette[numColors-1].b < 100 )
    {
      cContext.fillStyle = "#FFFFFF";
    }
    else
    {
      cContext.fillStyle = "#000000";
    }
    cContext.textAlign = "center";
    cContext.fillText(numColors, c.width/2, c.height/2); 
  }
}

/**************************************************************************************
FUNCTION PURPOSE: Convert the rgb value of our eyedropper color to hsv
PARMATERS: The r,g,b values of the color
REFRENCES: https://stackoverflow.com/questions/8022885/rgb-to-hsv-color-in-javascript
***************************************************************************************/

function RgbToHsv(r, g, b)
{
  let rabs, gabs, babs, rr, gg, bb, h, s, v, diff, diffc, percentRoundFn;
    rabs = r / 255;
    gabs = g / 255;
    babs = b / 255;
    v = Math.max(rabs, gabs, babs),
    diff = v - Math.min(rabs, gabs, babs);
    diffc = c => (v - c) / 6 / diff + 1 / 2;
    percentRoundFn = num => Math.round(num * 100) / 100;
    if (diff == 0) {
        h = s = 0;
    } else {
        s = diff / v;
        rr = diffc(rabs);
        gg = diffc(gabs);
        bb = diffc(babs);

        if (rabs === v) {
            h = bb - gg;
        } else if (gabs === v) {
            h = (1 / 3) + rr - bb;
        } else if (babs === v) {
            h = (2 / 3) + gg - rr;
        }
        if (h < 0) {
            h += 1;
        }else if (h > 1) {
            h -= 1;
        }
    }
    return {
        h: Math.round(h * 360),
        s: percentRoundFn(s * 100),
        v: percentRoundFn(v * 100)
    };
}

/**************************************************************************************
FUNCTION PURPOSE: Convert the hex value of our eyedropper color to rgb
PARMATERS: The hex value of the number
REFRENCES: https://stackoverflow.com/questions/5623838/rgb-to-hex-and-hex-to-rgb
***************************************************************************************/
function hexToRgb(hex) {
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  return result ? {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  } : null;
}